
package com.google.api.ads.adwords.jaxws.v201109.billing;

import java.util.List;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.ws.RequestWrapper;
import javax.xml.ws.ResponseWrapper;
import com.google.api.ads.adwords.jaxws.v201109.cm.Selector;


/**
 * 
 *       Service for managing {@link BudgetOrder}s.
 *       <p class="note"><b>Note:</b> This service is available only
 *       on a whitelist basis.</p>
 *     
 * 
 * This class was generated by the JAX-WS RI.
 * JAX-WS RI 2.1.6
 * Generated source version: 2.1
 * 
 */
@WebService(name = "BudgetOrderServiceInterface", targetNamespace = "https://adwords.google.com/api/adwords/billing/v201109")
@XmlSeeAlso({
    com.google.api.ads.adwords.jaxws.v201109.mcm.ObjectFactory.class,
    com.google.api.ads.adwords.jaxws.v201109.cm.ObjectFactory.class,
    com.google.api.ads.adwords.jaxws.v201109.info.ObjectFactory.class,
    com.google.api.ads.adwords.jaxws.v201109.billing.ObjectFactory.class,
    com.google.api.ads.adwords.jaxws.v201109.o.ObjectFactory.class,
    com.google.api.ads.adwords.jaxws.v201109.ch.ObjectFactory.class
})
public interface BudgetOrderServiceInterface {


    /**
     * 
     *         Gets a list of {@link BudgetOrder}s using the generic selector.
     *         @param serviceSelector specifies which BudgetOrder to return.
     *         @return A {@link BudgetOrderPage} of BudgetOrders of the client customer.
     *         All BudgetOrder fields are returned. Stats are not yet supported.
     *         @throws ApiException
     *       
     * 
     * @param serviceSelector
     * @return
     *     returns com.google.api.ads.adwords.jaxws.v201109.billing.BudgetOrderPage
     * @throws ApiException
     */
    @WebMethod
    @WebResult(name = "rval", targetNamespace = "https://adwords.google.com/api/adwords/billing/v201109")
    @RequestWrapper(localName = "get", targetNamespace = "https://adwords.google.com/api/adwords/billing/v201109", className = "com.google.api.ads.adwords.jaxws.v201109.billing.Get")
    @ResponseWrapper(localName = "getResponse", targetNamespace = "https://adwords.google.com/api/adwords/billing/v201109", className = "com.google.api.ads.adwords.jaxws.v201109.billing.GetResponse")
    public BudgetOrderPage get(
        @WebParam(name = "serviceSelector", targetNamespace = "https://adwords.google.com/api/adwords/billing/v201109")
        Selector serviceSelector)
        throws ApiException
    ;

    /**
     * 
     *         Returns all the open/active BillingAccounts associated with the current
     *         manager.
     *         @return a list of {@link BillingAccount}s
     *         @throws ApiException
     *       
     * 
     * @return
     *     returns java.util.List<com.google.api.ads.adwords.jaxws.v201109.billing.BillingAccount>
     * @throws ApiException
     */
    @WebMethod
    @WebResult(name = "rval", targetNamespace = "https://adwords.google.com/api/adwords/billing/v201109")
    @RequestWrapper(localName = "getBillingAccounts", targetNamespace = "https://adwords.google.com/api/adwords/billing/v201109", className = "com.google.api.ads.adwords.jaxws.v201109.billing.GetBillingAccounts")
    @ResponseWrapper(localName = "getBillingAccountsResponse", targetNamespace = "https://adwords.google.com/api/adwords/billing/v201109", className = "com.google.api.ads.adwords.jaxws.v201109.billing.GetBillingAccountsResponse")
    public List<BillingAccount> getBillingAccounts()
        throws ApiException
    ;

    /**
     * 
     *         Mutates BudgetOrders, supported operations are:
     *         <p>ADD: adds an BudgetOrder to the billing account specified by the
     *         billing account ID.
     *         <p>SET: sets the start/end date and amount of the BudgetOrder
     *         <p>REMOVE: cancels the BudgetOrder (status change).
     *         @param operations a list of operations, <b>however currently we only
     *         support one operation per mutate call</b>.
     *         @return an BudgetOrderReturnValue of BudgetOrders affected.
     *         @throws ApiException
     *       
     * 
     * @param operations
     * @return
     *     returns com.google.api.ads.adwords.jaxws.v201109.billing.BudgetOrderReturnValue
     * @throws ApiException
     */
    @WebMethod
    @WebResult(name = "rval", targetNamespace = "https://adwords.google.com/api/adwords/billing/v201109")
    @RequestWrapper(localName = "mutate", targetNamespace = "https://adwords.google.com/api/adwords/billing/v201109", className = "com.google.api.ads.adwords.jaxws.v201109.billing.Mutate")
    @ResponseWrapper(localName = "mutateResponse", targetNamespace = "https://adwords.google.com/api/adwords/billing/v201109", className = "com.google.api.ads.adwords.jaxws.v201109.billing.MutateResponse")
    public BudgetOrderReturnValue mutate(
        @WebParam(name = "operations", targetNamespace = "https://adwords.google.com/api/adwords/billing/v201109")
        List<BudgetOrderOperation> operations)
        throws ApiException
    ;

}
