
package com.google.api.ads.adwords.jaxws.v201109.o;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlType;


/**
 * 
 *             A {@link SearchParameter} that specifies the percentage of ad share expected
 *             in results. Absence of a {@link AdShareSearchParameter} in a
 *             {@link com.google.ads.api.services.targetingideas.TargetingIdeaSelector} is
 *             equivalent to having no constraint on ad share specified. This search
 *             parameter has a direct relationship to
 *             {@link com.google.ads.api.services.targetingideas.external.AttributeType#AD_SHARE}.
 *             <p>This element is supported by following {@link IdeaType}s: KEYWORD.
 *             <p>This element is supported by following {@link RequestType}s: IDEAS, STATS.
 *           
 * 
 * <p>Java class for AdShareSearchParameter complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="AdShareSearchParameter">
 *   &lt;complexContent>
 *     &lt;extension base="{https://adwords.google.com/api/adwords/o/v201109}SearchParameter">
 *       &lt;sequence>
 *         &lt;element name="operation" type="{https://adwords.google.com/api/adwords/o/v201109}DoubleComparisonOperation" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/extension>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "AdShareSearchParameter", propOrder = {
    "operation"
})
public class AdShareSearchParameter
    extends SearchParameter
{

    protected DoubleComparisonOperation operation;

    /**
     * Gets the value of the operation property.
     * 
     * @return
     *     possible object is
     *     {@link DoubleComparisonOperation }
     *     
     */
    public DoubleComparisonOperation getOperation() {
        return operation;
    }

    /**
     * Sets the value of the operation property.
     * 
     * @param value
     *     allowed object is
     *     {@link DoubleComparisonOperation }
     *     
     */
    public void setOperation(DoubleComparisonOperation value) {
        this.operation = value;
    }

}
