
package com.google.api.ads.adwords.jaxws.v201109_1.cm;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;


/**
 * 
 *             Adds, updates, or deletes campaigns.
 *             <p class="note"><b>Note:</b> {@link CampaignOperation} does not support the
 *             <code>REMOVE</code> operator. To delete a campaign, set its
 *             {@link Campaign#status status} to <code>DELETED</code>.</p>
 *             @param operations A list of unique operations.
 *             The same campaign cannot be specified in more than one operation.
 *             @return The list of updated campaigns, returned in the same order as the
 *             <code>operations</code> array.
 *             @throws ApiException if problems occurred while updating campaign information.
 *           
 * 
 * <p>Java class for mutate element declaration.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;element name="mutate">
 *   &lt;complexType>
 *     &lt;complexContent>
 *       &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *         &lt;sequence>
 *           &lt;element name="operations" type="{https://adwords.google.com/api/adwords/cm/v201109_1}CampaignOperation" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;/sequence>
 *       &lt;/restriction>
 *     &lt;/complexContent>
 *   &lt;/complexType>
 * &lt;/element>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "operations"
})
@XmlRootElement(name = "mutate")
public class CampaignServiceInterfacemutate {

    protected List<CampaignOperation> operations;

    /**
     * Gets the value of the operations property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the operations property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getOperations().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link CampaignOperation }
     * 
     * 
     */
    public List<CampaignOperation> getOperations() {
        if (operations == null) {
            operations = new ArrayList<CampaignOperation>();
        }
        return this.operations;
    }

}
