
package com.google.api.ads.adwords.jaxws.v201109_1.cm;

import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for CriterionError.Reason.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * <p>
 * <pre>
 * &lt;simpleType name="CriterionError.Reason">
 *   &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string">
 *     &lt;enumeration value="CONCRETE_TYPE_REQUIRED"/>
 *     &lt;enumeration value="INVALID_EXCLUDED_CATEGORY"/>
 *     &lt;enumeration value="INVALID_KEYWORD_TEXT"/>
 *     &lt;enumeration value="KEYWORD_TEXT_TOO_LONG"/>
 *     &lt;enumeration value="KEYWORD_HAS_TOO_MANY_WORDS"/>
 *     &lt;enumeration value="KEYWORD_HAS_INVALID_CHARS"/>
 *     &lt;enumeration value="INVALID_PLACEMENT_URL"/>
 *     &lt;enumeration value="INVALID_USER_LIST"/>
 *     &lt;enumeration value="INVALID_USER_INTEREST"/>
 *     &lt;enumeration value="INVALID_FORMAT_FOR_PLACEMENT_URL"/>
 *     &lt;enumeration value="PLACEMENT_URL_IS_TOO_LONG"/>
 *     &lt;enumeration value="PLACEMENT_URL_HAS_ILLEGAL_CHAR"/>
 *     &lt;enumeration value="PLACEMENT_URL_HAS_MULTIPLE_SITES_IN_LINE"/>
 *     &lt;enumeration value="PLACEMENT_IS_NOT_AVAILABLE_FOR_TARGETING_OR_EXCLUSION"/>
 *     &lt;enumeration value="INVALID_VERTICAL_PATH"/>
 *     &lt;enumeration value="CANNOT_EXCLUDE_CRITERIA_TYPE"/>
 *     &lt;enumeration value="CANNOT_ADD_CRITERIA_TYPE"/>
 *     &lt;enumeration value="INVALID_PRODUCT_FILTER"/>
 *     &lt;enumeration value="PRODUCT_FILTER_TOO_LONG"/>
 *     &lt;enumeration value="INVALID_CRITERION_ID"/>
 *     &lt;enumeration value="CANNOT_TARGET_CRITERION"/>
 *     &lt;enumeration value="CRITERION_ID_AND_TYPE_MISMATCH"/>
 *     &lt;enumeration value="INVALID_PROXIMITY_RADIUS"/>
 *     &lt;enumeration value="INVALID_PROXIMITY_RADIUS_UNITS"/>
 *     &lt;enumeration value="INVALID_STREETADDRESS_LENGTH"/>
 *     &lt;enumeration value="INVALID_CITYNAME_LENGTH"/>
 *     &lt;enumeration value="INVALID_REGIONCODE_LENGTH"/>
 *     &lt;enumeration value="INVALID_REGIONNAME_LENGTH"/>
 *     &lt;enumeration value="INVALID_POSTALCODE_LENGTH"/>
 *     &lt;enumeration value="INVALID_COUNTRY_CODE"/>
 *     &lt;enumeration value="INVALID_LATITUDE"/>
 *     &lt;enumeration value="INVALID_LONGITUDE"/>
 *     &lt;enumeration value="PROXIMITY_GEOPOINT_AND_ADDRESS_BOTH_CANNOT_BE_NULL"/>
 *     &lt;enumeration value="INVALID_PROXIMITY_ADDRESS"/>
 *     &lt;enumeration value="UNKNOWN"/>
 *   &lt;/restriction>
 * &lt;/simpleType>
 * </pre>
 * 
 */
@XmlType(name = "CriterionError.Reason")
@XmlEnum
public enum CriterionErrorReason {


    /**
     * 
     *                 Concrete type of criterion is required for ADD and SET operations.
     *               
     * 
     */
    CONCRETE_TYPE_REQUIRED,

    /**
     * 
     *                 The category requested for exclusion is invalid.
     *               
     * 
     */
    INVALID_EXCLUDED_CATEGORY,

    /**
     * 
     *                 Invalid keyword criteria text.
     *               
     * 
     */
    INVALID_KEYWORD_TEXT,

    /**
     * 
     *                 Keyword text should be less than 80 chars.
     *               
     * 
     */
    KEYWORD_TEXT_TOO_LONG,

    /**
     * 
     *                 Keyword text has too many words.
     *               
     * 
     */
    KEYWORD_HAS_TOO_MANY_WORDS,

    /**
     * 
     *                 Keyword text has invalid characters or symbols.
     *               
     * 
     */
    KEYWORD_HAS_INVALID_CHARS,

    /**
     * 
     *                 Invalid placement URL.
     *               
     * 
     */
    INVALID_PLACEMENT_URL,

    /**
     * 
     *                 Invalid user list criterion.
     *               
     * 
     */
    INVALID_USER_LIST,

    /**
     * 
     *                 Invalid user interest criterion.
     *               
     * 
     */
    INVALID_USER_INTEREST,

    /**
     * 
     *                 Placement URL has wrong format.
     *               
     * 
     */
    INVALID_FORMAT_FOR_PLACEMENT_URL,

    /**
     * 
     *                 Placement URL is too long.
     *               
     * 
     */
    PLACEMENT_URL_IS_TOO_LONG,

    /**
     * 
     *                 Indicates the URL contains an illegal character.
     *               
     * 
     */
    PLACEMENT_URL_HAS_ILLEGAL_CHAR,

    /**
     * 
     *                 Indicates the URL contains multiple comma separated URLs.
     *               
     * 
     */
    PLACEMENT_URL_HAS_MULTIPLE_SITES_IN_LINE,

    /**
     * 
     *                 Indicates the domain is blacklisted.
     *               
     * 
     */
    PLACEMENT_IS_NOT_AVAILABLE_FOR_TARGETING_OR_EXCLUSION,

    /**
     * 
     *                 Invalid vertical path.
     *               
     * 
     */
    INVALID_VERTICAL_PATH,

    /**
     * 
     *                 Criteria type can not be excluded by the customer,
     *                 like AOL account type cannot target site type criteria.
     *               
     * 
     */
    CANNOT_EXCLUDE_CRITERIA_TYPE,

    /**
     * 
     *                 Criteria type can not be targeted.
     *               
     * 
     */
    CANNOT_ADD_CRITERIA_TYPE,

    /**
     * 
     *                 Product filter in the product criteria has invalid characters.
     *                 Operand and the argument in the filter can not have "==" or "&+".
     *               
     * 
     */
    INVALID_PRODUCT_FILTER,

    /**
     * 
     *                 Product filter in the product criteria is translated to a string as
     *                 operand1==argument1&+operand2==argument2, maximum allowed length for
     *                 the string is 255 chars.
     *               
     * 
     */
    PRODUCT_FILTER_TOO_LONG,

    /**
     * 
     *                 The CriterionId does not exist or is of the incorrect type.
     *               
     * 
     */
    INVALID_CRITERION_ID,

    /**
     * 
     *                 The Criterion is not allowed to be targeted.
     *               
     * 
     */
    CANNOT_TARGET_CRITERION,

    /**
     * 
     *                 The CriterionId is not valid for the type.
     *               
     * 
     */
    CRITERION_ID_AND_TYPE_MISMATCH,

    /**
     * 
     *                 Distance for the radius for the proximity criterion is invalid.
     *               
     * 
     */
    INVALID_PROXIMITY_RADIUS,

    /**
     * 
     *                 Units for the distance for the radius for the proximity criterion is invalid.
     *               
     * 
     */
    INVALID_PROXIMITY_RADIUS_UNITS,

    /**
     * 
     *                 Street address is too short.
     *               
     * 
     */
    INVALID_STREETADDRESS_LENGTH,

    /**
     * 
     *                 City name in the address is too short.
     *               
     * 
     */
    INVALID_CITYNAME_LENGTH,

    /**
     * 
     *                 Region code in the address is too short.
     *               
     * 
     */
    INVALID_REGIONCODE_LENGTH,

    /**
     * 
     *                 Region name in the address is not valid.
     *               
     * 
     */
    INVALID_REGIONNAME_LENGTH,

    /**
     * 
     *                 Postal code in the address is not valid.
     *               
     * 
     */
    INVALID_POSTALCODE_LENGTH,

    /**
     * 
     *                 Country code in the address is not valid.
     *               
     * 
     */
    INVALID_COUNTRY_CODE,

    /**
     * 
     *                 Latitude for the GeoPoint is not valid.
     *               
     * 
     */
    INVALID_LATITUDE,

    /**
     * 
     *                 Longitude for the GeoPoint is not valid.
     *               
     * 
     */
    INVALID_LONGITUDE,

    /**
     * 
     *                 The Proximity input is not valid. Both address and geoPoint cannot be null.
     *               
     * 
     */
    PROXIMITY_GEOPOINT_AND_ADDRESS_BOTH_CANNOT_BE_NULL,

    /**
     * 
     *                 The Proximity address cannot be geocoded to a valid lat/long.
     *               
     * 
     */
    INVALID_PROXIMITY_ADDRESS,
    UNKNOWN;

    public String value() {
        return name();
    }

    public static CriterionErrorReason fromValue(String v) {
        return valueOf(v);
    }

}
