
package com.google.api.ads.adwords.jaxws.v201109_1.o;

import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for AttributeType.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * <p>
 * <pre>
 * &lt;simpleType name="AttributeType">
 *   &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string">
 *     &lt;enumeration value="UNKNOWN"/>
 *     &lt;enumeration value="AD_SHARE"/>
 *     &lt;enumeration value="APPROX_CONTENT_IMPRESSIONS_PER_DAY"/>
 *     &lt;enumeration value="AVERAGE_TARGETED_MONTHLY_SEARCHES"/>
 *     &lt;enumeration value="CATEGORY_PRODUCTS_AND_SERVICES"/>
 *     &lt;enumeration value="COMPETITION"/>
 *     &lt;enumeration value="CRITERION"/>
 *     &lt;enumeration value="EXTRACTED_FROM_WEBPAGE"/>
 *     &lt;enumeration value="FORMATS"/>
 *     &lt;enumeration value="GLOBAL_MONTHLY_SEARCHES"/>
 *     &lt;enumeration value="IDEA_TYPE"/>
 *     &lt;enumeration value="IN_STREAM_AD_INFO"/>
 *     &lt;enumeration value="NGRAM_GROUP"/>
 *     &lt;enumeration value="PLACEMENT_NAME"/>
 *     &lt;enumeration value="SAMPLE_URL"/>
 *     &lt;enumeration value="SEARCH_SHARE"/>
 *     &lt;enumeration value="PLACEMENT_CATEGORY"/>
 *     &lt;enumeration value="PLACEMENT_TYPE"/>
 *     &lt;enumeration value="TARGETED_MONTHLY_SEARCHES"/>
 *   &lt;/restriction>
 * &lt;/simpleType>
 * </pre>
 * 
 */
@XmlType(name = "AttributeType")
@XmlEnum
public enum AttributeType {


    /**
     * 
     *                 Value substituted in when the actual value is not available in the Web API
     *                 version being used.  (Please upgrade to the latest published WSDL.)
     *                 <p>This element is not supported directly by any {@link IdeaType}.
     *               
     * 
     */
    UNKNOWN,

    /**
     * 
     *                 Represents the percentage of the time that the advertiser's ad (if applicable)
     *                 was shown for queries associated with the given keyword idea.
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.DoubleAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: KEYWORD.
     *               
     * 
     */
    AD_SHARE,

    /**
     * 
     *                 Represents the (approximate) number of impressions per day for this placement idea on
     *                 the content network.
     *                 
     *                 Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.LongRangeAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: PLACEMENT.
     *               
     * 
     */
    APPROX_CONTENT_IMPRESSIONS_PER_DAY,

    /**
     * 
     *                 Represents the average number of searches (approximated) on this keyword idea, targeted
     *                 to the specified geographies.
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.LongAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: KEYWORD.
     *               
     * 
     */
    AVERAGE_TARGETED_MONTHLY_SEARCHES,

    /**
     * 
     *                 Represents a category ID in the "Products and Services" taxonomy.
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.IntegerSetAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: KEYWORD.
     *               
     * 
     */
    CATEGORY_PRODUCTS_AND_SERVICES,

    /**
     * 
     *                 Represents the relative amount of competition associated with the given keyword idea,
     *                 relative to other keywords. This value will be between 0 and 1 (inclusive).
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.DoubleAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: KEYWORD.
     *               
     * 
     */
    COMPETITION,

    /**
     * 
     *                 <p>This element is supported by following {@link IdeaType}s: KEYWORD, PLACEMENT.
     *               
     * 
     */
    CRITERION,

    /**
     * 
     *                 Represents the webpage from which this keyword idea was extracted (if applicable.)
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.WebpageDescriptorAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: KEYWORD.
     *               
     * 
     */
    EXTRACTED_FROM_WEBPAGE,

    /**
     * 
     *                 Represents the various types of ads & sizes of ads that may render within the given
     *                 placement idea.
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.AdFormatSpecListAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: PLACEMENT.
     *               
     * 
     */
    FORMATS,

    /**
     * 
     *                 Represents the (approximate) number of searches for the given keyword idea, independant of any
     *                 geo settings.
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.LongAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: KEYWORD.
     *               
     * 
     */
    GLOBAL_MONTHLY_SEARCHES,

    /**
     * 
     *                 Represents the type of the given idea.
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.IdeaTypeAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: KEYWORD, PLACEMENT.
     *               
     * 
     */
    IDEA_TYPE,

    /**
     * 
     *                 Represents the duration(s)/other instream information, for the given placement idea.
     *                 (if applicable)
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.InStreamAdInfoAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: PLACEMENT.
     *               
     * 
     */
    IN_STREAM_AD_INFO,

    /**
     * 
     *                 Represents the ngram group for the given keyword idea. An ngram group is the longest
     *                 matching substring of the keyword, that is also common to many other keywords. For instance,
     *                 the ngram group for both the keywords "car rental" and "car rental coupons" is "car rental".
     *                 However, for the keyword "car leasing", the ngram group is "car" because "car leasing" is not
     *                 considered common.
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.StringAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: KEYWORD.
     *               
     * 
     */
    NGRAM_GROUP,

    /**
     * 
     *                 Represents the publisher given name of the given placement idea (if applicable).
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.StringAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: PLACEMENT.
     *               
     * 
     */
    PLACEMENT_NAME,

    /**
     * 
     *                 Represents a sample page upon which the given placement idea shows from the content network.
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.StringAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: PLACEMENT.
     *               
     * 
     */
    SAMPLE_URL,

    /**
     * 
     *                 Represents the percentage of the time that the advertiser's webpage (if applicable)
     *                 was shown for queries associated with the given keyword idea.
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.DoubleAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: KEYWORD.
     *               
     * 
     */
    SEARCH_SHARE,

    /**
     * 
     *                 Represents a category id for a category within the category hierarchy for placement ideas.
     *                 
     *                 Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.IntegerAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: PLACEMENT.
     *               
     * 
     */
    PLACEMENT_CATEGORY,

    /**
     * 
     *                 Represents the type of media of the given placement idea.  Some examples of this could include:
     *                 videos on the web, web sites, flash games on the content network, website feeds, etc.
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.PlacementTypeAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: PLACEMENT.
     *               
     * 
     */
    PLACEMENT_TYPE,

    /**
     * 
     *                 Represents the (approximated) number of searches on this keyword idea (as available for the
     *                 past twelve months), targeted to the specified geographies.
     *                 
     *                 <p>Resulting attribute is
     *                 {@link com.google.ads.api.services.common.optimization.attributes.MonthlySearchVolumeAttribute}.
     *                 <p>This element is supported by following {@link IdeaType}s: KEYWORD.
     *               
     * 
     */
    TARGETED_MONTHLY_SEARCHES;

    public String value() {
        return name();
    }

    public static AttributeType fromValue(String v) {
        return valueOf(v);
    }

}
