
package com.google.api.ads.adwords.jaxws.v201109_1.o;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlType;


/**
 * 
 *             A {@link SearchParameter} that constrains the approximate average number of
 *             targeted monthly searches on ideas to be returned. Absence of a
 *             {@link AverageTargetedMonthlySearchesSearchParameter} in a
 *             {@link com.google.ads.api.services.targetingideas.TargetingIdeaSelector} is
 *             equivalent to having no constraint on average targeted monthly searches
 *             pecified.
 *             <p>This element is supported by following {@link IdeaType}s: KEYWORD.
 *             <p>This element is supported by following {@link RequestType}s: IDEAS, STATS.
 *           
 * 
 * <p>Java class for AverageTargetedMonthlySearchesSearchParameter complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="AverageTargetedMonthlySearchesSearchParameter">
 *   &lt;complexContent>
 *     &lt;extension base="{https://adwords.google.com/api/adwords/o/v201109_1}SearchParameter">
 *       &lt;sequence>
 *         &lt;element name="operation" type="{https://adwords.google.com/api/adwords/o/v201109_1}LongComparisonOperation" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/extension>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "AverageTargetedMonthlySearchesSearchParameter", propOrder = {
    "operation"
})
public class AverageTargetedMonthlySearchesSearchParameter
    extends SearchParameter
{

    protected LongComparisonOperation operation;

    /**
     * Gets the value of the operation property.
     * 
     * @return
     *     possible object is
     *     {@link LongComparisonOperation }
     *     
     */
    public LongComparisonOperation getOperation() {
        return operation;
    }

    /**
     * Sets the value of the operation property.
     * 
     * @param value
     *     allowed object is
     *     {@link LongComparisonOperation }
     *     
     */
    public void setOperation(LongComparisonOperation value) {
        this.operation = value;
    }

}
