
package com.google.api.ads.adwords.jaxws.v201109_1.o;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlType;
import com.google.api.ads.adwords.jaxws.v201109_1.cm.KeywordMatchType;


/**
 * 
 *             A {@link SearchParameter} for {@code KEYWORD} {@link IdeaType}s that
 *             specifies the {@link KeywordMatchType}s that all results must match.
 *             For example, results may be limited to only Broad or Exact matches.
 *             Setting no {@link KeywordMatchTypeSearchParameter} will match all
 *             targeting ideas, regardless of {@link KeywordMatchType}. If multiple
 *             {@link KeywordMatchType}s are set, a result need only match one
 *             match type to be returned.
 *             <p>This element is supported by following {@link IdeaType}s: KEYWORD.
 *             <p>This element is supported by following {@link RequestType}s: IDEAS, STATS.
 *           
 * 
 * <p>Java class for KeywordMatchTypeSearchParameter complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="KeywordMatchTypeSearchParameter">
 *   &lt;complexContent>
 *     &lt;extension base="{https://adwords.google.com/api/adwords/o/v201109_1}SearchParameter">
 *       &lt;sequence>
 *         &lt;element name="keywordMatchTypes" type="{https://adwords.google.com/api/adwords/cm/v201109_1}KeywordMatchType" maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/extension>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "KeywordMatchTypeSearchParameter", propOrder = {
    "keywordMatchTypes"
})
public class KeywordMatchTypeSearchParameter
    extends SearchParameter
{

    protected List<KeywordMatchType> keywordMatchTypes;

    /**
     * Gets the value of the keywordMatchTypes property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the keywordMatchTypes property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getKeywordMatchTypes().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link KeywordMatchType }
     * 
     * 
     */
    public List<KeywordMatchType> getKeywordMatchTypes() {
        if (keywordMatchTypes == null) {
            keywordMatchTypes = new ArrayList<KeywordMatchType>();
        }
        return this.keywordMatchTypes;
    }

}
